image: python:3.8

### declare stages ###

workflow:
  rules:
    # only run manually
    - if: '$CI_PIPELINE_SOURCE == "web"'
    - if: '$CI_PIPELINE_SOURCE == "schedule"'

stages:
  - test
  - build
  - deploy


### poetry and pip setup ###

variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

.poetry_script: &poetry_script
  - pip install --no-input poetry
  - poetry config virtualenvs.in-project true
  - poetry install -vv -n

.poetry_cache: &poetry_cache
  key: poetrycache
  paths:
    - .cache/pip
    - .venv/

.pip_cache: &pip_cache
  key: pipcache
  paths:
    - .cache/pip


### test stage ###


test:
  stage: test
  before_script: *poetry_script
  script:
    - poetry run test
  cache:
    <<: *poetry_cache


### build stage ###


build package:
  stage: build
  before_script: *poetry_script
  script:
    - poetry build -n
  cache:
    <<: *poetry_cache
    policy: pull        # don't save
  artifacts:
    paths:
      - dist


build docs:
  stage: build
  before_script: *poetry_script
  script:
    - poetry run docs
    - mkdir public/
    - cp -r ./docs/_build/html/ public/
  cache:
    <<: *poetry_cache
    policy: pull        # don't save
  artifacts:
    paths:
      - public


### deploy stage ###


test wheel:
  stage: deploy
  script:
    - DIS=$(find ./dist/ -name "*.whl" | head -n 1)
    - pip install $DIS
  cache:
    <<: *pip_cache
  dependencies: 
    - build package


test sdist:
  stage: deploy
  script:
    - DIS=$(find ./dist/ -name "*.tar.gz" | head -n 1)
    - pip install $DIS
  cache:
    <<: *pip_cache
    policy: pull        # don't save
  dependencies:
    - build package
